--[[

    
    mPlay turns music on/off dependent on the zone you're in.
    Copyright (C) 2014-2015 Lilih @ Defias Brotherhood (EU)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    
--]]

mPlay = {}
mPlayBlock = {}

local L = LibStub("AceLocale-3.0"):GetLocale("mPlay")
mPlay = LibStub("AceAddon-3.0"):NewAddon("mPlay", 'AceEvent-3.0', 'AceConsole-3.0')
local mpMMicon = LibStub("LibDBIcon-1.0")

BINDING_HEADER_MPLAY = "mPlay";
BINDING_NAME_MPLAYOPTIONS = "Options";

--[[
*******************
* Local variables *
--]]
local db
local icon = "\124TInterface\\Icons\\trade_archaeology_delicatemusicbox"
local continent_icon = {
	[-1] = "spell_arcane_portaldarnassus",
	"achievement_zone_kalimdor_01",
	"achievement_zone_easternkingdoms_01",
	"achievement_zone_outland_01",
	"achievement_zone_northrend_01",
	"achievement_zone_easternkingdoms_01",
	"expansionicon_mistsofpandaria",
	"achievement_zone_draenor_01",
}
local zone_icon = {
	   [9] = "achievement_zone_mulgore_01",
	   [4] = "achievement_zone_durotar",
	  [11] = "achievement_zone_barrens_01",
	  [16] = "achievement_zone_arathihighlands_01",
	  [17] = "achievement_zone_badlands_01",
	  [19] = "achievement_zone_blastedlands_01",
	  [20] = "achievement_zone_tirisfalglades_01",
	  [21] = "achievement_zone_silverpine_01",
	  [22] = "achievement_zone_westernplaguelands_01",
	  [23] = "achievement_zone_easternplaguelands",
	  [24] = "achievement_zone_hillsbradfoothills",
	  [26] = "achievement_zone_hinterlands_01",
	  [27] = "achievement_zone_dunmorogh",
	  [28] = "achievement_zone_searinggorge_01",
	  [29] = "achievement_zone_burningsteppes_01",
	  [30] = "achievement_zone_elwynnforest",
	  [32] = "achievement_zone_deadwindpass",
	  [34] = "achievement_zone_duskwood",
	  [35] = "achievement_zone_lochmodan",
	  [36] = "achievement_zone_redridgemountains",
	  [37] = "achievement_zone_stranglethorn_01",
	  [38] = "achievement_zone_swampsorrows_01",
	  [39] = "achievement_zone_westfall_01",
	  [40] = "achievement_zone_wetlands_01",
	  [41] = "achievement_zone_darnassus",
	  [42] = "achievement_zone_darkshore_01",
	  [43] = "achievement_zone_ashenvale_01",
	  [61] = "achievement_zone_thousandneedles_01",
	  [81] = "achievement_zone_stonetalon_01",
	 [101] = "achievement_zone_desolace",
	 [121] = "achievement_zone_feralas",
	 [141] = "achievement_zone_dustwallowmarsh",
	 [161] = "achievement_zone_tanaris_01",
	 [181] = "achievement_zone_azshara_01",
	 [201] = "achievement_zone_ungorocrater_01",
	 [241] = "spell_arcane_teleportmoonglade",
	 [261] = "achievement_zone_silithus_01",
	 [281] = "achievement_zone_winterspring",
	 [-10] = "achievement_zone_durotar",
	 [462] = "achievement_zone_eversongwoods",
	 [463] = "achievement_zone_ghostlands",
	 [464] = "achievement_zone_azuremystisle_01",
	 [465] = "achievement_zone_hellfirepeninsula_01",
	 [467] = "achievement_zone_zangarmarsh",
	 [473] = "achievement_zone_shadowmoon",
	 [475] = "achievement_zone_bladesedgemtns_01",
	 [476] = "achievement_zone_bloodmystisle_01",
	 [477] = "achievement_zone_nagrand_01",
	 [478] = "achievement_zone_terrokar",
	 [479] = "achievement_zone_netherstorm_01",
	 [486] = "achievement_zone_boreantundra_01",
	 [488] = "achievement_zone_dragonblight_01",
	 [490] = "achievement_zone_grizzlyhills_01",
	 [491] = "achievement_zone_howlingfjord_01",
	 [492] = "achievement_zone_icecrown_01",
	 [493] = "achievement_zone_sholazar_01",
	 [495] = "achievement_zone_stormpeaks_01",
	 [496] = "achievement_zone_zuldrak_03",
	 [499] = "achievement_zone_isleofqueldanas",
	 [502] = "spell_arcane_teleportundercity",
	 [510] = "achievement_zone_crystalsong_01",
	 [545] = "ability_mount_whitedirewolf",
	 [-06] = "achievement_zone_mount-hyjal",
	 [610] = "achievement_zone_vashjir",
	 [611] = "ability_mount_whitedirewolf",
	 [613] = "achievement_zone_vashjir",
	 [614] = "achievement_zone_vashjir",
	 [615] = "achievement_zone_vashjir",
	 [673] = "achievement_zone_stranglethorn_01",
	 [684] = "achievement_worganhead",
	 [720] = "achievement_zone_uldum",
	 [607] = "achievement_zone_barrens_01",
	 [640] = "achievement_zone_deepholm",
	 [700] = "achievement_zone_twilighthighlands",
	 [806] = "achievement_zone_jadeforest",
	 [807] = "achievement_zone_valleyoffourwinds",
	 [809] = "achievement_zone_kunlaisummit",
	 [810] = "achievement_zone_townlongsteppes",
	 [811] = "achievement_zone_valeofeternalblossoms",
	 [864] = "achievement_zone_elwynnforest",
	 [857] = "achievement_zone_krasarangwilds",
	 [858] = "achievement_zone_dreadwastes",
	 [890] = "achievement_zone_mulgore_01",
	 [895] = "achievement_zone_dunmorogh",
	 [928] = "spell_nature_callstorm",
	 [929] = "ability_hunter_pet_devilsaur",
	 [941] = "achievement_zone_frostfire",
	 [946] = "achievement_zone_talador",
	 [947] = "achievement_zone_newshadowmoonvalley",
	 [948] = "achievement_zone_spiresofarak",
	 [949] = "achievement_zone_gorgrond",
	 [950] = "achievement_zone_nagrand_02",
	 [951] = "inv_misc_coinbag_special",
	 [970] = "achievement_zone_draenor_01",
	 [978] = "achievement_zone_ashran",
	[1009] = "inv_tabard_a_78wrynnvanguard",
	[1011] = "inv_tabard_a_77voljinsspear",
}
local ZoneChanged = 0

local defaults = {
    profile =  {
    	debug = false,
    	mContinent = {},
      mpMMbutton = {
      	hide = false,
      },
      mpLDBhints = {
    		hide = false,
    	},
    	mpLDBver = {
    		hide = false,
    	},
    	mpLDBzone = {
    		hide = false,
    	},
    	mPlay = true,
      mZones = {},
      mZoneIDs = {},
      NotifyNew = false,
      NotifyMusic = false,
    },
}

--[[
***************
* minimap/LDB *
--]]
mPlayBlock = LibStub("LibDataBroker-1.1"):NewDataObject("mPlay", {
	type = "data source", text = "mPlay", icon = "Interface\\Icons\\trade_archaeology_delicatemusicbox",
	OnClick = function(self, button)
		if button == "LeftButton" and db.mPlay == true then
			mPlay.musicOnOff()
  	elseif button == "RightButton" and IsAltKeyDown() and not db.mpMMbutton.hide then
  		db.mpMMbutton.hide = not db.mpMMbutton.hide
  		mpMMicon:Hide("mPlayBlock")
		elseif button == "RightButton" then
			mPlay.OpenOptions()
		end
	end,
	OnTooltipShow = function(tooltip)
		if not db.mpLDBver.hide then
			tooltip:SetText(icon..":14\124t mPlay v"..GetAddOnMetadata("mPlay", "version"),0.5,0.5,0.5,0.5,0)
		end
		if db.mPlay == true and not db.mpLDBzone.hide then
			local	Continent = {
			L["Kalimdor"], L["Eastern Kingdoms"],	L["Outland"], L["Northrend"], L["The Maelstrom"], L["Pandaria"], L["Draenor"],
			}
			mPlay.FindZone()
			if zone ~= nil then
				if db.mZones[zone] == 0 then
					mPlayBlock.text = "|cffff0000"..zone
				elseif db.mZones[zone] == 1 then
					mPlayBlock.text = "|cff00ff00"..zone
				end
				if db.mPlay == false then
					tooltip:AddDoubleLine(icon..":14\124t |cffffffff<|cffffff00mPlay|cffffffff>|r "..L["is"].." |cffff0000"..L["disabled"])
				elseif db.mPlay == true then
					if db.mContinent[zone] ~= -1 and db.mZoneIDs[zone] ~= 502 and db.mZoneIDs[zone] ~= 970 then
						tooltip:AddDoubleLine("|cffffffff"..L["Continent"]..": \124TInterface\\Icons\\"..continent_icon[db.mContinent[zone]]..":18\124t |cffffff00"..Continent[db.mContinent[zone]])
					elseif db.mContinent[zone] == -1 and db.mZoneIDs[zone] == 502 then
						tooltip:AddDoubleLine("|cffffffff"..L["Continent"]..": |cffffff00"..L["The Scarlet Enclave"])
					elseif db.mContinent[zone] == -1 and db.mZoneIDs[zone] == 970 then
						tooltip:AddDoubleLine("|cffffffff"..L["Continent"]..": \124TInterface\\Icons\\"..continent_icon[7]..":18\124t |cffffff00"..L["Draenor"])
					else
						tooltip:AddDoubleLine("|cffffffff"..L["Continent"]..": |cffffff00"..L["Dungeon"])
					end
					tooltip:AddLine(" ")
					local c = GetCurrentMapContinent()
					for key,value in mPlay.pairsByKeys(db.mZones) do
						if db.mContinent[key] == c then
							if value == 1 and key == zone then
								if zone_icon[db.mZoneIDs[key]] then
									tooltip:AddDoubleLine("\124TInterface\\Icons\\"..zone_icon[db.mZoneIDs[key]]..":14\124t |cffffff00"..key.."|cffffffff*|r","|cff00ff00"..L["On"])
								else
									tooltip:AddDoubleLine("\124TInterface\\Icons\\"..continent_icon[db.mContinent[zone]]..":14\124t |cffffff00"..key.."|cffffffff*|r","|cff00ff00"..L["On"])
								end
							elseif value == 1 then
								if zone_icon[db.mZoneIDs[key]] then
									tooltip:AddDoubleLine("\124TInterface\\Icons\\"..zone_icon[db.mZoneIDs[key]]..":14\124t |cff888888"..key,"|cff00ff00"..L["On"])
								else
									tooltip:AddDoubleLine("\124TInterface\\Icons\\"..continent_icon[db.mContinent[zone]]..":14\124t |cff888888"..key,"|cff00ff00"..L["On"])
								end
							elseif value == 0 and key == zone then
								if zone_icon[db.mZoneIDs[key]] then
									tooltip:AddDoubleLine("\124TInterface\\Icons\\"..zone_icon[db.mZoneIDs[key]]..":14\124t |cffffff00"..key.."|cffffffff*|r","|cffff0000"..L["Off"])
								else
									tooltip:AddDoubleLine("\124TInterface\\Icons\\"..continent_icon[db.mContinent[zone]]..":14\124t |cffffff00"..key.."|cffffffff*|r","|cffff0000"..L["Off"])
								end
							elseif value == 0 then
								if zone_icon[db.mZoneIDs[key]] then
									tooltip:AddDoubleLine("\124TInterface\\Icons\\"..zone_icon[db.mZoneIDs[key]]..":14\124t |cff888888"..key,"|cffff0000"..L["Off"])
								else
									tooltip:AddDoubleLine("\124TInterface\\Icons\\"..continent_icon[db.mContinent[zone]]..":14\124t |cff888888"..key,"|cffff0000"..L["Off"])
								end
							end
						end
					end
				end
			elseif zone == nil then
				mPlayBlock.text = "mPlay"
				tooltip:AddDoubleLine("\124TInterface\\Icons\\inv_misc_questionmark:14\124t |cffffffff<|cffffff00"..L["No Zone"].."|cffffffff>|r")
			end
		end
		if not db.mpLDBhints.hide then
			tooltip:AddLine(" ")
			tooltip:AddLine("|cffeda55f"..L["Left-Click"].."|r "..L["turns music on/off"], 0.2, 1, 0.2)
			tooltip:AddLine("|cffeda55f"..L["Right-Click"].."|r "..L["for options"], 0.2, 1, 0.2)
			if not db.mpMMbutton.hide then tooltip:AddLine("|cffeda55f"..L["Alt+Right-Click"].."|r "..L["hide minimap button"], 0.2, 1, 0.2) end
		end
	end,
})

--[[
*****************
* mPlay options *
--]]
local mPlayOptions = {
	handler = mPlay,
	type = 'group',
	childGroups = "tab",
	name = icon..":16\124t |CFF71D5FF[mPlay]|r",
	order = 1,
	args = {
		options = {
			name = icon..":16\124t "..L["Options"],
			order = 1,
			type = "group",
			args = {
				mPlay = {
 					type = "toggle",
   				name = L["Enable"].." mPlay",
					order = 0,
     			get = "getMPopt",
     			set = "setMPopt",
				},
				mpTab = {
					type = "description",
					name = "",
					order = 1,
 				},
		 		mpTab1 = {
					type = "description",
					name = "|cffbbbbbbNotify on",
					order = 2,
 				},
 				NotifyMusic = {
 					type = "toggle",
   				name = L["music on/off"],
					order = 3,
     			get = "getMPopt",
     			set = "setMPopt",
				},
				mpTab2 = {
					type = "description",
					name = "",
					order = 4,
 				},
				NotifyNew = {
 					type = "toggle",
   				name = L["new zone"],
					order = 5,
     			get = "getMPopt",
     			set = "setMPopt",
				},
		 		mpTab3 = {
					type = "description",
					name = "",
					order = 6,
 				},
 				mpMMdesc = {
					type = "description",
					name = "|cffbbbbbb"..L["Hide from minimap/LDB"],
					order = 7,
 				},
 				mpMMbutton = {
 					type = "toggle",
   				name = L["button"],
					order = 8,
     			get = function(info)
     				return db.mpMMbutton.hide
     				end,
     			set = function()
     				db.mpMMbutton.hide = not db.mpMMbutton.hide
     				if db.mpMMbutton.hide then mpMMicon:Hide("mPlayBlock")
     				else mpMMicon:Show("mPlayBlock") end
     				end,
				},
				mpTab4 = {
					type = "description",
					name = "",
					order = 9,
 				},
				mpLDBhints = {
 					type = "toggle",
   				name = L["hints"],
					order = 10,
     			get = function(info) return db.mpLDBhints.hide end,
     			set = function() db.mpLDBhints.hide = not db.mpLDBhints.hide end,
				},
				mpTab5 = {
					type = "description",
					name = "",
					order = 11,
 				},
				mpLDBver = {
 					type = "toggle",
   				name = L["title"],
					order = 12,
     			get = function(info) return db.mpLDBver.hide end,
     			set = function() db.mpLDBver.hide = not db.mpLDBver.hide end,
				},
				mpTab6 = {
					type = "description",
					name = "",
					order = 13,
 				},
 				mpLDBzone = {
 					type = "toggle",
   				name = L["zones"],
					order = 14,
     			get = function(info) return db.mpLDBzone.hide end,
     			set = function() db.mpLDBzone.hide = not db.mpLDBzone.hide end,
				},
		 		mpTab7 = {
					type = "description",
					name = "",
					order = 15,
 				},
				mpLine = {
			  	type = "header",
			  	name = "|cffbbbbbb"..L["About"],
			  	order = 16,
				},
				logdesc = {
					type = "description",
					name = L["ABOUT_TEXT"](GetAddOnMetadata("mPlay", "version")),
					order = 17,
				},
 			},
 		},
	},
}

--[[
***************************
* SLASH COMMAND ARGUMENTS *
--]]
local mPlayOptionsSlash = {
	handler = mPlay,
	name = SlashCommand,
	order = -3,
	type = "group",
	args = {
		intro = {
			name = "SlashDescription",
			type = "description",
			order = 1,
			cmdHidden = true,
		},
		a = {
			name = "About",
			desc = "(|cffffff00A|r)bout",
			type = 'execute',
			order = 2,
			func = function()
				DEFAULT_CHAT_FRAME:AddMessage("|cffffffff<|cffffff00mPlay|cffffffff>|r v"..GetAddOnMetadata("mPlay", "Version").."|cffffffff -|r "..GetAddOnMetadata("mPlay", "Notes").."|r")
				DEFAULT_CHAT_FRAME:AddMessage("|cffffffff<|cffffff00Author|cffffffff>|r "..GetAddOnMetadata("mPlay", "X-Email").."|r")
				DEFAULT_CHAT_FRAME:AddMessage("|cffffffff<|cffffff00Website|cffffffff>|r "..GetAddOnMetadata("mPlay", "X-Website").."|r")
				end,
			cmdHidden = false
		},
		c = {
			name = "Config",
			desc = "(|cffffff00C|r)onfigure",
			type = 'execute',
			order = 3,
			func = "OpenOptions",
			dialogHidden = true,
		},
		debug = {
			name = "Debug",
			desc = "(|cffffff00D|r)ebug on/off",
			type = 'execute',
			order = 3,
			func = function()
				if db.debug == false then
					db.debug = true
					DEFAULT_CHAT_FRAME:AddMessage(icon..":12\124t Debug is |cff00ff00on")
				else
					db.debug = false
					DEFAULT_CHAT_FRAME:AddMessage(icon..":12\124t Debug is |cffff0000off")
				end
				end,
			dialogHidden = true,
			cmdHidden = true
		},
		l = {
			name = "Status",
			desc = "(|cffffff00L|r)ist all saved zones",
			type = 'execute',
			order = 6,
			func = "ListAllZones",
			dialogHidden = true,
		},
		m = {
			name = "Music",
			desc = "(|cffffff00M|r)usic on/off",
			type = 'execute',
			order = 5,
			func = "musicOnOff",
			dialogHidden = true,
		},
		t = {
			name = "Toggle",
			desc = "(|cffffff00T|r)oggle mPlay on/off",
			type = 'execute',
			order = 6,
			func = "mpOnOff",
			dialogHidden = true,
		},
	},
}

--[[
****************
* OnInitialize *
--]]
function mPlay:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("mPlayDB", defaults)
	db = self.db.profile
	mPlay.db.RegisterCallback(self, "OnProfileChanged", "OnProfileChanged")
	mPlay.db.RegisterCallback(self, "OnProfileCopied", "OnProfileChanged")
	mPlay.db.RegisterCallback(self, "OnProfileReset", "OnProfileChanged")	
	local AceConfig = LibStub("AceConfig-3.0")
	local AceConfigDialog = LibStub("AceConfigDialog-3.0")
	local about_panel = LibStub:GetLibrary("LibAboutPanel", true)
	
	if about_panel then
		self.optionsFrame = about_panel.new(nil, "mPlay")
	end
	
	AceConfig:RegisterOptionsTable("mPlayOptions", mPlayOptions)
  AceConfig:RegisterOptionsTable("mPlay Profiles", LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db))
  AceConfigDialog:AddToBlizOptions("mPlayOptions", L["Options"], "mPlay")
  AceConfigDialog:AddToBlizOptions("mPlay Profiles", "Profiles", "mPlay")
  
	LibStub("AceConfig-3.0"):RegisterOptionsTable("mPlay commands", mPlayOptionsSlash, "mp")
	LibStub("AceConfig-3.0"):RegisterOptionsTable("mPlay commands", mPlayOptionsSlash, "mplay")
	
	mpMMicon:Register("mPlayBlock", mPlayBlock, db.mpMMbutton)
	if db.mPlay == true then mPlay.CheckZone() end
	DEFAULT_CHAT_FRAME:AddMessage(icon..":12\124t |cffffffff<|cffffff00mPlay|cffffffff>|r v"..GetAddOnMetadata("mPlay", "version").." initialized. Type |cffffff00/mp|r for command arguments.")
end

--[[
************
* OnEnable *
--]]
function mPlay:OnEnable()
	self:RegisterEvent("ZONE_CHANGED")
	self:RegisterEvent("ZONE_CHANGED_NEW_AREA")
	self:RegisterEvent("ZONE_CHANGED_INDOORS")
end

--[[
********************
* OnProfileChanged *
--]]
function mPlay.OnProfileChanged(event, database, newProfileKey)
	mPlay.db = LibStub("AceDB-3.0"):New("mPlayDB", defaults)
  db = mPlay.db.profile
 	mPlay.db.RegisterCallback(mPlay, "OnProfileChanged", "OnProfileChanged")
	mPlay.db.RegisterCallback(mPlay, "OnProfileCopied", "OnProfileChanged")
	mPlay.db.RegisterCallback(mPlay, "OnProfileReset", "OnProfileChanged")
	LibStub("LibDBIcon-1.0"):Refresh("mPlayBlock", db.mpMMbutton)
	mPlayBlock.text = "mPlay"
	mPlay.CheckZone()
end

--[[
****************
* ZONE_CHANGED *
--]]
function mPlay:ZONE_CHANGED()
	if ZoneChanged == 1 then
		mPlay.CheckZone()
		ZoneChanged = 0
	end
end

--[[
*************************
* ZONE_CHANGED_NEW_AREA *
--]]
function mPlay:ZONE_CHANGED_NEW_AREA()
	if db.mPlay == true then
		ZoneChanged = 1
		mPlay.CheckZone()
	end
end

--[[
************************
* ZONE_CHANGED_INDOORS *
--]]
function mPlay:ZONE_CHANGED_INDOORS()
	if db.mPlay == true then
		mPlay.CheckZone()
	end
end

--[[
*************
* CheckZone *
--]]
function mPlay.CheckZone()
	mPlay.FindZone()
	if db.mZoneIDs[zone] == GetCurrentMapAreaID() and db.mPlay == true and zone ~= nil then
		SetCVar("Sound_EnableMusic",db.mZones[zone])
		if db.mZones[zone] == 1 then
			mPlayBlock.text = "|cff00ff00"..zone
		elseif db.mZones[zone] == 0 then
			mPlayBlock.text = "|cffff0000"..zone
		end
	elseif db.mPlay == true and zone ~= nil and GetCurrentMapAreaID() ~= 13 then
		db.mZones[zone] = 1
		db.mZoneIDs[zone] = GetCurrentMapAreaID()
		db.mContinent[zone] = GetCurrentMapContinent()
		SetCVar("Sound_EnableMusic",db.mZones[zone])
		mPlayBlock.text = "|cff00ff00"..zone
		if db.NotifyNew == true then DEFAULT_CHAT_FRAME:AddMessage(icon..":12\124t |cffffffff<|cffffff00mPlay|cffffffff>|r "..L["New"].." "..L["zone"].."! <|cff00ff00"..zone.."|r>") end
	end
end

--[[
************
* FindZone *
--]]
function mPlay.FindZone()
	SetMapToCurrentZone()
	local c = GetCurrentMapContinent()
	local a = GetCurrentMapAreaID()
	local t = GetZoneText()
	local n = GetMapNameByID(a)
	if c == 0 or a == 962 or a == 862 or a == 485 or a == 14 or (a == 30 and t ==  L["The Great Sea"]) or (a == -1 and t ==  L["Twisting Nether"]) or (a == 510 and t ==  L["The Frozen Sea"]) or a == 873 or t == L["The Veiled Stair"] then
		zone = nil
		mPlayBlock.text = "mPlay"
	elseif a == 811 and t == L["Shrine of Seven Stars"] then zone = L["Shrine of Seven Stars"]
	elseif a == 928 and t == L["Townlong Steppes"] then zone = L["Townlong Steppes"]
	elseif a == 928 and t == L["Isle of Thunder"] then zone = L["Isle of Thunder"]
	elseif a == 477 and t == L["Nagrand"] then zone = L["Nagrand (Outland)"]
	elseif a == 473 and t == L["Shadowmoon Valley"] then zone = L["Shadowmoon Valley (Outland)"]
	elseif n ~= nil then zone = n
	end
	return zone
end

--[[
****************
* ListAllZones *
--]]
function mPlay.ListAllZones()
	SetMapToCurrentZone()
	local t = GetZoneText()
	DEFAULT_CHAT_FRAME:AddMessage(icon..":12\124t |cffffffff<|cffffff00mPlay|cffffffff>|r")
	for key,value in mPlay.pairsByKeys(db.mZones) do
		if value == 0 then
			if key == t then
				DEFAULT_CHAT_FRAME:AddMessage("\124TInterface\\Icons\\"..continent_icon[db.mContinent[key]]..":12\124t |cffffff00"..key.."|r* "..L["is"].." |cffff0000"..string.lower(L["Off"]))
			else
				DEFAULT_CHAT_FRAME:AddMessage("\124TInterface\\Icons\\"..continent_icon[db.mContinent[key]]..":12\124t |cffffff00"..key.."|r "..L["is"].." |cffff0000"..string.lower(L["Off"]))
			end
		elseif value == 1 then
			if key == t then
				DEFAULT_CHAT_FRAME:AddMessage("\124TInterface\\Icons\\"..continent_icon[db.mContinent[key]]..":12\124t |cffffff00"..key.."|r* "..L["is"].." |cff00ff00"..string.lower(L["On"]))
			else
				DEFAULT_CHAT_FRAME:AddMessage("\124TInterface\\Icons\\"..continent_icon[db.mContinent[key]]..":12\124t |cffffff00"..key.."|r "..L["is"].." |cff00ff00"..string.lower(L["On"]))
			end
		end
	end
end

--[[
********************
* Open GUI options *
--]]
function mPlay.OpenOptions()
	PlaySound("igSpellBookOpen")
	local MAJOR, MINOR = "InterfaceOptionsFix", 1
	local frame = _G[MAJOR] or CreateFrame("Frame", MAJOR, _G.InterfaceOptionsFrame)
	frame.version = MINOR
	if not frame.Saved_InterfaceOptionsFrame_OpenToCategory then
    frame.Saved_InterfaceOptionsFrame_OpenToCategory = _G.InterfaceOptionsFrame_OpenToCategory
    hooksecurefunc("InterfaceOptionsFrame_OpenToCategory", function(...)
    	return frame:InterfaceOptionsFrame_OpenToCategory(...)
    end)
    frame:SetScript('OnUpdate', function(_, ...)
        return frame:OnUpdate(...)
    end)
	end
	function frame:InterfaceOptionsFrame_OpenToCategory(panel)
  	self.panel = panel
	end
	function frame:OnUpdate()
    local panel = self.panel   
    self:SetScript('OnUpdate', nil)
    self:Hide()
    self.panel = nil
    self.InterfaceOptionsFrame_OpenToCategory = function() end
    self.Saved_InterfaceOptionsFrame_OpenToCategory(panel)
	end
	InterfaceOptionsFrame_OpenToCategory(mPlay.optionsFrame)
end

--[[
***************
* pairsByKeys *
--]]
function mPlay.pairsByKeys (t, f)
	local a = {}
		for n in pairs(t) do table.insert(a, n) end
		table.sort(a, f)
		local i = 0      -- iterator variable
		local iter = function ()   -- iterator function
			i = i + 1
			if a[i] == nil then return nil
			else return a[i], t[a[i]]
			end
		end
	return iter
end

--[[
***********
* musicOnOff *
--]]
function mPlay.musicOnOff()
	if db.mPlay == true then
		mPlay.CheckZone()
			if db.mZones[zone] == 0 then
				db.mZones[zone] = 1
				if db.NotifyMusic then DEFAULT_CHAT_FRAME:AddMessage(icon..":12\124t |cffffffff<|cffffff00mPlay|cffffffff>|r "..L["is"].." |cff00ff00"..L["enabled"].."|r "..L["in"].." "..zone) end
				mPlayBlock.text = "|cff00ff00"..zone
			else
				db.mZones[zone] = 0
				if db.NotifyMusic then DEFAULT_CHAT_FRAME:AddMessage(icon..":12\124t |cffffffff<|cffffff00mPlay|cffffffff>|r "..L["is"].." |cffff0000"..L["disabled"].."|r "..L["in"].." "..zone) end
				mPlayBlock.text = "|cffff0000"..zone
			end
  	SetCVar("Sound_EnableMusic",db.mZones[zone])
  end
end

--[[
***********
* mpOnOff *
--]]
function mPlay.mpOnOff()
	db.mPlay = not db.mPlay
	if db.mPlay == false then
		DEFAULT_CHAT_FRAME:AddMessage(icon..":12\124t |cffffffff<|cffffff00mPlay|cffffffff>|r "..L["is"].." |cffff0000"..L["disabled"])
		mPlayBlock.text = "mPlay"
	else
		DEFAULT_CHAT_FRAME:AddMessage(icon..":12\124t |cffffffff<|cffffff00mPlay|cffffffff>|r "..L["is"].." |cff00ff00"..L["enabled"])
		mPlay.CheckZone()
	end
end

--[[
************
* getMPopt *
--]]
function mPlay:getMPopt(info, ...)
	return db[info[#info]]
end

--[[
************
* setMPopt *
--]]
function mPlay:setMPopt(info, newValue)
	db[info[#info]] = newValue
	if db.mPlay == false then mPlayBlock.text = "mPlay"
	else mPlay.CheckZone()
	end
end